﻿B4J=true
Group=Modules
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private appointment_modal As Form
	Private tfSearchString As TextField
	Private tblAppointments As TableView
	
	Private dtpSchedule As DatePicker
	Private chbAppointmentTime As ChoiceBox
	
	Private openMode As String
End Sub

Public Sub LoadLayout
	MDI.Workarea.InnerNode.RemoveNodeFromParent
	MDI.Workarea.LoadLayout("appointments", MDI.Workarea.InnerNode.PrefWidth, MDI.Workarea.InnerNode.PrefHeight)
	openMode = "VIEW"
	Wait For (getAppointments) Complete (Success As Boolean)
	
End Sub

Private Sub getAppointments As ResumableSub
	
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	Try
		Dim qry As String = "SELECT id, [clientid] as ClientId, [notes] As Notes, [dateTime] As Schedule, [status] As Status FROM appointments WHERE published = ?  ORDER BY id DESC LIMIT 15"
		Dim SenderFilter As Object = Libraries.SQL.ExecQueryAsync("SQL", qry, Array As String(1))
		Wait For (SenderFilter) SQL_QueryComplete (Success As Boolean, rs As ResultSet)
		If Success Then
			tblAppointments.Items.Clear
			Dim cols As List
			cols.Initialize
			cols.Add("Id")
			cols.Add("ClientId")
			cols.Add("Notes")
			cols.Add("Schedule")
			cols.Add("Status")
			tblAppointments.SetColumns(cols)
			Do While rs.NextRow
				Dim values(rs.ColumnCount) As String
				For col = 0 To rs.ColumnCount - 1
					values(col) = rs.GetString2(col)
				Next
				tblAppointments.Items.Add(values)
			Loop
		Else
			Log(LastException)
		End If
		
	Catch
		Log(LastException.Message)
	End Try
	
	Libraries.SQL.Close
	Return True
End Sub

Private Sub btnAdd_MouseClicked (EventData As MouseEvent)

	openMode = "ADD"
	
	If appointment_modal.IsInitialized = False Then
		appointment_modal.Initialize("appointment_modal", 500, 400)
		appointment_modal.RootPane.LoadLayout("appointment_modal")
		Metro.ApplyTheme(appointment_modal,"Light")
		appointment_modal.SetFormStyle("UNDECORATED")
		appointment_modal.Resizable = False
	End If
	
	chbAppointmentTime.Items.AddAll(Array As String("08:00 AM", "08:30 AM", "09:00 AM", "09:30 AM", "10:00 AM", "10:30 AM", "11:00 AM", _
	"11:30 AM", "12:00 PM", "12:30 PM", "01:00 PM", "01:30 PM", "02:00 PM", "02:30 PM", "03:00 PM", "03:30 PM", "04:00 PM", "04:30 PM", _
	"05:00 PM", "05:30 PM",	"06:00 PM", "06:30 PM", "07:00 PM", "07:30 PM", "08:00 PM", "08:30 PM", "09:00 PM", "09:30 PM", "10:00 PM"))
	

	appointment_modal.ShowAndWait
	appointment_modal.Close
End Sub

Private Sub btnClose_MouseClicked (EventData As MouseEvent)
	appointment_modal.Close
End Sub
