﻿B4J=true
Group=Modules
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private client_modal As Form
	Private tblClients As TableView
	Private tfSearchString As TextField
	Private dtBirthdate As DatePicker
	Private imgProfilePic As ImageView
	Private taNotes As TextArea
	Private tfAge As TextField
	Private tfEmail As TextField
	Private tfFirstname As TextField
	Private tfLastname As TextField
	Private tfPhone As TextField
	Private chbGender As ChoiceBox
	Private chbNationality As ChoiceBox
	Private dtLastVisit As DatePicker
	Private dtCreatedAt As DatePicker
	Private dtUpdatedAt As DatePicker
	
	Private bDate As Long
	Private chGender As Int
	Private chNationality As Int
	
End Sub

Public Sub LoadLayout
	MDI.Workarea.InnerNode.RemoveNodeFromParent
	MDI.Workarea.LoadLayout("client_list", MDI.Workarea.InnerNode.PrefWidth, MDI.Workarea.InnerNode.PrefHeight)
	Wait For (getClients) Complete (Success As Boolean)
	
End Sub

Private Sub getClients As ResumableSub
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	Try
		Dim qry As String = "SELECT id, [phone] as Phone, [firstname] As Firstname, [lastname] As Lastname, [lastvisit] As 'Last Visit' FROM clients WHERE published = ?  ORDER BY id DESC LIMIT 15"
		Dim SenderFilter As Object = Libraries.SQL.ExecQueryAsync("SQL", qry, Array As String(1))
		Wait For (SenderFilter) SQL_QueryComplete (Success As Boolean, rs As ResultSet)
		If Success Then
			tblClients.Items.Clear
			Dim cols As List
			cols.Initialize
			cols.Add("Id")
			cols.Add("Phone")
			cols.Add("Firstname")
			cols.Add("Lastname")
			cols.Add("Last Visit")
			tblClients.SetColumns(cols)
			Do While rs.NextRow
				Dim values(rs.ColumnCount) As String
				For col = 0 To rs.ColumnCount - 1
					values(col) = rs.GetString2(col)
				Next
				tblClients.Items.Add(values)
			Loop
		Else
			Log(LastException)
		End If
		
	Catch
		Log(LastException.Message)
	End Try
	
	Libraries.SQL.Close
	Return True
End Sub

Private Sub btnSearch_MouseClicked (EventData As MouseEvent)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	Try
		Dim qry As String = "SELECT id, [phone] as Phone, [firstname] As Firstname, [lastname] As Lastname, [lastvisit] As 'Last Visit' FROM clients WHERE phone LIKE ? ORDER BY id DESC LIMIT 15"
		Dim SenderFilter As Object = Libraries.SQL.ExecQueryAsync("SQL", qry, Array As String("%" & tfSearchString.Text & "%"))
		Wait For (SenderFilter) SQL_QueryComplete (Success As Boolean, rs As ResultSet)
		If Success Then
			tblClients.Items.Clear
				Dim cols As List
				cols.Initialize
				cols.Add("Id")
				cols.Add("Phone")
				cols.Add("Firstname")
				cols.Add("Lastname")
				cols.Add("Last Visit")
				tblClients.SetColumns(cols)
				Do While rs.NextRow
					Dim values(rs.ColumnCount) As String
					For col = 0 To rs.ColumnCount - 1
						values(col) = rs.GetString2(col)
					Next
					tblClients.Items.Add(values)
				Loop
			rs.Close
		Else
			Log(LastException)
		End If
	Catch
		Log(LastException.Message)
	End Try
	
	Libraries.SQL.Close

End Sub

Private Sub btnAddClient_MouseClicked (EventData As MouseEvent)
	
	Variables.openMode = "ADD"
	
	If client_modal.IsInitialized = False Then
		client_modal.Initialize("client_modal", 650, 520)
		client_modal.RootPane.LoadLayout("client_modal")
		client_modal.SetFormStyle("UNDECORATED")
		client_modal.Resizable = False
	End If
	
	chbNationality.Items.AddAll(Array As String("American", "Australian", "Bangladeshi", "British", "Egyptian", "Emirati", "Filipino", "French", "German", "Indian", "Iranian", "Kenyan",  "Nigerian", "Pakistani", "Russian", "South African", "Sri Lankan"))
	chbGender.Items.AddAll(Array As String("Male", "Female", "Others"))
	chbGender.SelectedIndex = -1
	chbNationality.SelectedIndex = -1
	client_modal.ShowAndWait
	client_modal.Close
	
End Sub

Private Sub client_modal_Closed
	client_modal.Close
End Sub

Private Sub btnClose_MouseClicked (EventData As MouseEvent)
	client_modal.Close
End Sub

Private Sub btnUpdate_MouseClicked (EventData As MouseEvent)
	
	Dim firstName As String = tfFirstname.Text
	Dim lastName As String = tfLastname.Text
	Dim phoneNo As String = tfPhone.Text
	Dim email As String = tfEmail.Text
	Dim bDateTicks As String = bDate
	Dim age As String = tfAge.Text
	Dim gender As String = chGender
	Dim nationality As String = chNationality
	Dim notes As String = taNotes.Text
'	Dim profilePhoto As String = imgProfilePic.GetImage
	Dim createdAtTicks As String = DateTime.DateTimeParse(DateTime.Date(DateTime.Now), DateTime.Time(DateTime.Now))
	Dim createdBy As Int = Variables.userId
	Dim updatedAtTicks As String = DateTime.DateTimeParse(DateTime.Date(DateTime.Now), DateTime.Time(DateTime.Now))
	Dim updatedBy As Int = Variables.userId
	
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	Libraries.SQL.BeginTransaction
	
	If Variables.openMode = "ADD" Then
		Try
			Libraries.SQL.ExecNonQuery2($"INSERT INTO clients
				(firstname, lastname, phone, email, birthdate, age, gender, nationality, notes, createdAt, createdBy, updatedAt, updatedBy, published)
				VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?)"$, Array As Object(firstName, lastName, phoneNo, email, bDateTicks, _
				age, gender, nationality, notes, createdAtTicks, createdBy, updatedAtTicks, updatedBy, 1))
	
			Libraries.SQL.TransactionSuccessful
			Libraries.XUI.MsgboxAsync("New client added.", "Success")
		Catch
			Libraries.XUI.MsgboxAsync("Error saving.", "Error")
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	else if Variables.openMode = "EDIT" Then
		Try
			Libraries.SQL.ExecNonQuery2($"UPDATE clients SET firstname = ?, lastname = ?, phone = ?, email = ?, birthdate = ?, age = ?, gender = ?, nationality = ?, notes = ?, updatedAt = ?, updatedBy = ?, published = ? WHERE id = ${Variables.clientId}"$, _
			Array As Object(firstName, lastName, phoneNo, email, bDateTicks, age, gender, nationality, notes, updatedAtTicks, updatedBy, 1))
	
			Libraries.SQL.TransactionSuccessful
			Libraries.XUI.MsgboxAsync("Client Updated.", "Success")
		Catch
			Libraries.XUI.MsgboxAsync("Error updating.", "Error")
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
	
	Variables.openMode = "EDIT"
	
	Libraries.SQL.Close
	
End Sub

Private Sub dtBirthdate_ValueChanged (SelectedDate As Long)
	
	bDate = SelectedDate
	Dim yr As Int = DateTime.GetYear(DateTime.Now) - DateTime.GetYear(SelectedDate)
	tfAge.Text = yr
'	Log(bDate)
	
End Sub

Private Sub chbGender_SelectedIndexChanged(Index As Int, Value As Object)
	chGender = Index
'	Log(Value)
End Sub

Private Sub chbNationality_SelectedIndexChanged(Index As Int, Value As Object)
	chNationality = Index
'	Log(Value)
End Sub

Sub nullDate_Handler(nullDate As String) As String
	If nullDate = Null Then
		Dim tempDate As Long = DateTime.DateParse("01/01/1950") 
'		Log(tempDate)
		Return tempDate
	Else
		Return nullDate
	End If
End Sub

Private Sub btnOpenClient_MouseClicked (EventData As MouseEvent)
'	Dim rowId As Int = tblClients.SelectedRow
	Dim row() As Object = tblClients.SelectedRowValues
'	Log(row(0))

	openMode = "EDIT"
	
	If client_modal.IsInitialized = False Then
		client_modal.Initialize("client_modal", 650, 520)
		Metro.ApplyTheme(client_modal,"Light")
		client_modal.RootPane.LoadLayout("client_modal")
		Metro.ApplyTheme(client_modal,"Light")
		client_modal.SetFormStyle("UNDECORATED")
		client_modal.Resizable = False
	End If
	
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	Try
		Dim qry As String = "SELECT * FROM clients WHERE published = ?  AND id = ?"
		Dim SenderFilter As Object = Libraries.SQL.ExecQueryAsync("SQL", qry, Array As Object(1, row(0)))
		Wait For (SenderFilter) SQL_QueryComplete (Success As Boolean, rs As ResultSet)
		
		Do While rs.NextRow
			Variables.clientId = rs.GetInt("id")
			Variables.clientFirstname = rs.GetString("firstname")
			Variables.clientLastname = rs.GetString("lastname")
			Variables.clientPhone = rs.GetString("phone")
			Variables.clientEmail = rs.GetString("email")
			Variables.clientBirthdate = rs.GetString("birthdate")
			Variables.clientAge = rs.GetInt("age")
			Variables.clientGender = rs.GetInt("gender")
			Variables.clientNationality = rs.GetInt("nationality")
			Variables.clientLastVisit = rs.GetString("lastvisit")
			Variables.clientNotes = rs.GetString("notes")
			Variables.clientProfilePhoto = rs.GetString("profilephoto")
			Variables.clientCreatedAt = rs.GetString("createdAt")
			Variables.clientCreatedBy = rs.GetInt("createdBy")
			Variables.clientUpdatedAt = rs.GetString("updatedAt")
			Variables.clientUpdatedBy = rs.GetInt("updatedBy")
			Variables.clientPublished = rs.GetInt("updatedBy")
		Loop
	Catch
		Log(LastException.Message)
	End Try
	
	chbNationality.Items.AddAll(Array As String("American", "Australian", "Bangladeshi", "British", "Egyptian", "Emirati", "Filipino", "French", "German", "Indian", "Iranian", "Kenyan",  "Nigerian", "Pakistani", "Russian", "South African", "Sri Lankan"))
	chbGender.Items.AddAll(Array As String("Male", "Female", "Others"))
	
	tfFirstname.Text = Variables.clientFirstname
	tfLastname.Text = Variables.clientlastname
	tfPhone.Text = Variables.clientPhone
	tfEmail.Text = Variables.clientEmail
	dtBirthdate.DateTicks = Variables.clientBirthdate
	tfAge.Text = Variables.clientAge
	chbGender.SelectedIndex = Variables.clientGender
	chbNationality.SelectedIndex = Variables.clientNationality
	dtLastVisit.DateTicks = nullDate_Handler(Variables.clientLastVisit)
	taNotes.Text = Variables.clientNotes
	dtCreatedAt.DateTicks = Variables.clientCreatedAt
	dtUpdatedAt.DateTicks = Variables.clientUpdatedAt
	
	client_modal.ShowAndWait
End Sub
