﻿B4J=true
Group=Modules
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

Private Sub initDBTables
	Dim status(1) As Int
	
	CreateUserGroupsTable(status)
	CreateUsersTable(status)
	CreateClientsTable(status)
	CreateItemsTable(status)
	CreateEquipmentTable(status)
	CreateAppointmentsTable(status)
	CreateAppointmentItemsTable(status)
	CreateBillingTable(status)
	CreatePaymentsTable(status)
	InsertUserGroup(status)
	InsertAdmin(status)
	
	Do While status(0) < 11
		Sleep(50)
	Loop
End Sub

Private Sub CreateUsersTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "users") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS users(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			username		TEXT,
			password		TEXT,
			firstname		TEXT,
			lastname		TEXT,
			groupid			INTEGER,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published			INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
End Sub

Private Sub CreateUserGroupsTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "user_groups") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS user_groups(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			group_name		TEXT,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published			INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
	
End Sub

Private Sub CreateClientsTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "clients") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS clients(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			firstname		TEXT,
			lastname		TEXT,
			phone			TEXT,
			email			TEXT,
			birthdate		TEXT,
			age				INT,
			gender			TEXT,
			nationality		TEXT,
			lastvisit		TEXT,
			notes			BLOB,
			profilephoto	BLOB,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published		INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
	
End Sub

Private Sub CreateItemsTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "items") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS items(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			name			TEXT,
			description		TEXT,
			type			TEXT,
			unitprice		REAL,
			quantity		INT,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published		INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
	
End Sub

Private Sub CreateEquipmentTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "equipment") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS equipment(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			name			TEXT,
			description		TEXT,
			quantity		INT,
			status			TEXT,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published		INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
	
End Sub

Private Sub CreateAppointmentsTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "appointments") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS appointments(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			clientId		INT,
			notes			BLOB,
			dateTime		TEXT,
			status			TEXT,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published		INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
	
End Sub

Private Sub CreateAppointmentItemsTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "appointmentItems") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS appointmentItems(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			appointmentId	INT,
			itemId			INT,
			quantity		INT,
			unitPrice		REAL,
			itemCost		REAL,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published		INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
	
End Sub

Private Sub CreateBillingTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "billing") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS billing(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			refNo			TEXT,
			appointmentId	INT,
			paymentId		INT,
			totalCost		REAL,
			status			TEXT,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published		INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
	
End Sub

Private Sub CreatePaymentsTable(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "payments") = False Then
		Libraries.SQL.BeginTransaction
		Try
			Libraries.SQL.ExecNonQuery($"CREATE TABLE IF NOT EXISTS payments(
			id 				INTEGER 	PRIMARY KEY 	AUTOINCREMENT,
			refNo			TEXT,
			datetime		TEXT,
			billingId		INT,
			totalCost		REAL,
			amountPaid		REAL,
			paymentType		TEXT,
			ccNumber		TEXT,
			ccReceiptNo		TEXT,
			status			TEXT,
			createdAt		TEXT,
			updatedAt		TEXT,
			createdBy		TEXT,
			updatedBy		TEXT,
			published		INTEGER 
		)"$)
		
			Libraries.SQL.TransactionSuccessful
			status(0) = status(0) + 1
		Catch
			Log(LastException.Message)
			Libraries.SQL.RollBack 'no changes will be made
		End Try
	End If
		
	Libraries.SQL.Close
	
End Sub

Private Sub InsertUserGroup(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "user_groups") Then
		Dim hasGroup As Int
		hasGroup = Libraries.SQL.ExecQuerySingleResult2("SELECT COUNT(id) FROM user_groups WHERE group_name = ?", Array As String("administrators"))
		
		If hasGroup < 1 Then
			Libraries.SQL.BeginTransaction
			Try
				Libraries.SQL.ExecNonQuery2($"INSERT INTO user_groups
			(group_name, createdAt, updatedAt, createdBy, updatedBy, published)
			VALUES (?,?,?,?,?,?)"$, Array As Object("administrators", _
			$"${DateTime.Date(DateTime.Now)} ${DateTime.Time(DateTime.Now)}"$, _
			$"${DateTime.Date(DateTime.Now)} ${DateTime.Time(DateTime.Now)}"$, _
			1,1,1))
			
				Libraries.SQL.TransactionSuccessful
				status(0) = status(0) + 1
			
			Catch
				Log(LastException.Message)
				Libraries.SQL.RollBack 'no changes will be made
			End Try
		End If
	End If
	
	Libraries.SQL.Close
	
End Sub

Private Sub InsertAdmin(status() As Int)
	If Libraries.SQL.IsInitialized = False Then
		Libraries.SQL.InitializeSQLite(File.DirApp, "zalon.db", True)
	End If
	
	If DBUtils.TableExists(Libraries.SQL, "users") Then
		Dim hasAdmin As Int
		hasAdmin = Libraries.SQL.ExecQuerySingleResult2("SELECT COUNT(id) FROM users WHERE groupid = ?", Array As String(1))
		
		If hasAdmin < 1 Then
			Libraries.SQL.BeginTransaction
			Try
				Libraries.SQL.ExecNonQuery2($"INSERT INTO users
					(username, password, firstname, lastname, groupid, createdAt, updatedAt, createdBy, updatedBy, published)
					VALUES (?,?,?,?,?,?,?,?,?,?)"$, Array As Object("admin", Controls.SHA256("password"), "firstname", "lastname", 1, _
					$"${DateTime.Date(DateTime.Now)} ${DateTime.Time(DateTime.Now)}"$, _
					$"${DateTime.Date(DateTime.Now)} ${DateTime.Time(DateTime.Now)}"$, _
					1,1,1))
		
				Libraries.SQL.TransactionSuccessful
				status(0) = status(0) + 1
			Catch
				Log(LastException.Message)
				Libraries.SQL.RollBack 'no changes will be made
			End Try
		End If
	
	End If
	
	Libraries.SQL.Close
	
End Sub
